::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
:: set environment and elevate script in UAC systems
::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

@echo off
setlocal

:: change shell codepage to CP1252 in order to support umlauts in path
chcp 1252 > nul

call "..\shared\setenv.bat"

:: reset shell codepage to CP850
chcp 850 > nul

:: check for UAC and Mandatory Label\High Mandatory Level 

:: without enabledelayedexpansion ERRORLEVEL of nested command couldn't be read
setlocal enabledelayedexpansion

:: test for UAC environment by starting 'whoami.exe', exitcode!=0 if not found
whoami.exe > nul 2>&1

if "!ERRORLEVEL!"=="0" (

   :: test if already elevated by checking group membership
   whoami.exe /groups | find "S-1-16-12288" > nul

   :: relaunch elevated and exit if not running as elevated user                                        
   if not "!ERRORLEVEL!"=="0" ( 
      call "%TC_HOME%\shared\elevate.cmd" cmd /D /C "cd /d """%CD%""" && """%~dpnx0""" %*" & goto :eof
   )
)

endlocal

::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

:: TRANSCONNECT Update
:: (c) 2012-2014 by SQL Projekt AG Dresden

title TRANSCONNECT Update

:: check parameters  

if {%1}=={} (
   echo Usage: tcupdate.bat ^<update_container^> ^[-q tc_version tc_build^]
   echo -q: Quiet Mode ^(no user interaction^)
   goto :eof
)

if not exist %1 (
   echo Update container does not exist.
   goto :eof
)

:: prepare update  

if exist "%TC_HOME%\update\tmp" (
   rmdir /S /Q "%TC_HOME%\update\tmp"
)

if exist "%TC_HOME%\update\jre" (
   rmdir /S /Q "%TC_HOME%\update\jre"
)

if exist "%TC_HOME%\update\jdk" (
   rmdir /S /Q "%TC_HOME%\update\jdk"
)

if exist "%TC_HOME%\update\lib" (
   del /Q "%TC_HOME%\update\lib\*" > nul
) else (
   mkdir "%TC_HOME%\update\lib"
)

echo Extracting update container...
"%TC_HOME%\update\bin\7za.exe" x %1 -o"%TC_HOME%\update\tmp" > nul 

if "%ERRORLEVEL%"=="0" (
   echo ...OK
) else (
   goto :eof
)

echo Copying required libraries...
xcopy "%TC_HOME%\update\tmp\lib" /Q /R /Y /E /I "%TC_HOME%\update\lib" > nul
xcopy "%TC_HOME%\update\tmp\build\tcupdate.jar" "%TC_HOME%\update\lib" > nul
xcopy "%TC_HOME%\update\tmp\build\tcclient.jar" "%TC_HOME%\update\lib" > nul

:: copy JDK and overwrite updated JRE files 

echo Copying JDK to temporary directory...
xcopy "%TC_HOME%\shared\jdk" /Q /R /Y /E /I "%TC_HOME%\update\jdk" > nul

if exist "%TC_HOME%\update\tmp\setup\win64\shared\jdk" (
   xcopy "%TC_HOME%\update\tmp\setup\win64\shared\jdk" /Q /R /Y /E /I "%TC_HOME%\update\jdk" > nul
)

:: prepare environment and start updater 

set CLASSPATH=%TC_HOME%\update\lib\*
set JAVA_HOME=%TC_HOME%\update\jdk
set JAVA_OPTS=-Xms32m -Xmx64m -Dconsole.encoding=CP850

echo Starting updater...

"%JAVA_HOME%\bin\java.exe" %JAVA_OPTS% -classpath "%CLASSPATH%" com.sqlag.tc.update.console.UpdateConsole %* & (
   :: cleanup
   rmdir /S /Q "%TC_HOME%\update\jdk" > nul 2>&1
   if exist "%TC_HOME%\update\tmp" (
      rmdir /S /Q "%TC_HOME%\update\tmp" > nul 2>&1
   )
   if exist "%TC_HOME%\update\lib" (
      rmdir /S /Q "%TC_HOME%\update\lib" > nul 2>&1
   )
   goto :eof
)

endlocal